<?php

/**
 * @author craCkpot
 * @copyright 2009
 */
 
if (isset($_POST['do_cache']))
{
	// parse this beyatch
	
	require_once(dirname(__FILE__) . '/config.php');
	
	$errors = array();	// in case we run into any problems
	$success = array();	// thinking positive
	$s_count = 0;		// for keeping track on the number added to the cache
	$f_count = 0;		// amount that have failed
	if (!file_exists(dirname(__FILE__) . '/itemcache.sql') || filesize(dirname(__FILE__) . '/itemcache.sql') == 0)
	{
		$errors[] = 'itemcache.sql not found or invalid format.';	
	}
	else
	{
		// connect to sql and select the database
		$db = mysql_connect(WHP_DB_HOST, WHP_DB_USER, WHP_DB_PASS);
		mysql_select_db(WHP_DB_NAME, $db);
		
		$lang = (empty($_POST['lang'])) ? 'en' : $_POST['lang'];
		$clear_cache = (bool)$_POST['clear_cache'];
		
		if ($clear_cache == true)
		{
			$dummy = mysql_query("TRUNCATE TABLE " . WHP_CACHE_TBL);
			
			if ($dummy)
			{
				$success[] = 'Item cache was cleared.';
			}
			else
			{
				$errors[] = 'Clearing of the item cache failed.';
			}
		}
		
		// now time for the dirty part
		if (!$handle = @fopen(dirname(__FILE__) . '/itemcache.sql', 'r'))
		{
			$errors[] = 'Failed to open itemcache.sql.';
		}
		else
		{
			while (!feof($handle))
			{
				$line = @fgets($handle);
				if (trim($line) != '')
				{
					$parts = explode(';', $line);
					$query_text = "INSERT INTO " . WHP_CACHE_TBL . " 
						VALUES (
							NULL,
							" . $parts[0] . ",
							'" . addslashes($parts[1]) . "',
							'" . addslashes($parts[1]) . "',
							" . $parts[2] . ",
							NULL,
							'item',
							'" . $lang . "',
							NULL,
							NULL
						)
					";
					$query = mysql_query($query_text, $db);
					
					if ($query)
					{
						$s_count++;
					}
					else
					{
						$f_count++;	
					}
				}
			}
			
			if ($s_count > 0)
			{
				$success[] = (string)$s_count . ' items successfully added to the cache.';	
			}
			
			if ($f_count > 0)
			{
				$errors[] = (string)$f_count . ' items failed to be added to the cache.';	
			}
			fclose($handle); mysql_close($db);	
		}
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>Itemcache Parser</title>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
		<style type="text/css">
			body
			{
				background: #fff;
				font-family: arial;
				font-size: 10px;
				color: #000;	
			}
			
			.maintbl
			{
				border: 1px solid #000;
				width: 250px;
			}
			
			th, th a:link, th a:active, th a:hover, th a:visited
			{
				background: #000;
				font-family: arial;
				font-size: 10px;
				color: #fff;
				text-decoration: none;	
			}
			
			.red
			{
				color: #ff0000;
				font-weight: bold;	
			}
			
			.green
			{
				color: #00ff00;
				font-weight: bold;	
			}
			
			input, select
			{
				background: transparent;
				color: #000;
				border: 1px solid #000;
				font-family: arial;
				font-size: 10px;	
			}
			
		</style>
	</head>
	<body>
		<div align="center">
			<form action="cache_parser.php" method="post">
				<table class="maintbl" cellspacing="0" cellpadding="2">
					<tr><th>Itemcache Parser</th></tr>
					<tr>
						<td>
							<?php
							if (!file_exists(dirname(__FILE__) . '/itemcache.sql'))
							{
								print "<span class=\"red\">itemcache.sql not found.</span><br/>";	
							}
							
							if (isset($errors) && sizeof($errors) > 0)
							{
								foreach ($errors as $error)
								{
									print "<span class=\"red\">$error</span><br/>";	
								}
								
								unset($errors);
							}
							
							if (isset($success) && sizeof($success) > 0)
							{
								foreach ($success as $wins)
								{
									print "<span class=\"green\">$wins</span><br/>";	
								}
								
								unset($success);
							}
							?>
							<strong>Language:</strong>
							<select name="lang">
								<option value="en" selected="yes">English (EN)</option>
								<option value="es">Spanish (ES)</option>
								<option value="de">German (DE)</option>
								<option value="ru">Russian (RU)</option>
								<option value="fr">French (FR)</option>
							</select><br/>
							<input type="checkbox" name="clear_cache" checked="true" />Clear Cache Before Parsing (Recommended)
						</td>
					</tr>
					<tr>
						<td align="center"><input type="submit" name="do_cache" value="Add Items" /></td>
					</tr>
				</table>
			</form>
		</div>
	</body>
</html>